sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"}],"id":"api-reference","title":"API Reference"},{"group":"","headers":[{"anchor":"client-sdks","id":"Client SDKs"},{"anchor":"installation","id":"Installation"},{"anchor":"usage","id":"Usage"},{"anchor":"developing","id":"Developing"},{"anchor":"copyright-and-license","id":"Copyright and License"}],"id":"readme","title":"Membrane RTC Engine"},{"group":"","headers":[],"id":"license","title":"LICENSE"},{"group":"Developer docs","headers":[{"anchor":"table-of-contents","id":"Table of contents"},{"anchor":"client-rtc-engine","id":"Client -&gt; RTC Engine"},{"anchor":"rtc-engine-client","id":"RTC Engine -&gt; Client"},{"anchor":"client-webrtc-enpoint","id":"Client -&gt; WebRTC Enpoint"},{"anchor":"webrtc-enpoint-client","id":"WebRTC Enpoint -&gt; Client"}],"id":"media_events","title":"Media Events"},{"group":"Developer docs","headers":[],"id":"protocol","title":"Signaling Protocol"},{"group":"Developer docs","headers":[{"anchor":"architecture","id":"Architecture"},{"anchor":"track-sender","id":"Track Sender"},{"anchor":"track-receiver","id":"Track Receiver"}],"id":"webrtc_endpoint","title":"WebRTC Endpoint"},{"group":"Developer docs","headers":[{"anchor":"codecs","id":"Codecs"},{"anchor":"logic","id":"Logic"},{"anchor":"forwarder","id":"Forwarder"},{"anchor":"mungers","id":"Mungers"},{"anchor":"disabling-simulcast","id":"Disabling Simulcast"}],"id":"internal_simulcast","title":"Simulcast"},{"group":"Developer docs","headers":[],"id":"internal_engine_architecture","title":"Engine Architecture"},{"group":"Guides","headers":[{"anchor":"managing-track-variants","id":"Managing track variants"}],"id":"track_lifecycle","title":"Track Lifecycle"},{"group":"Guides","headers":[{"anchor":"general-rules","id":"General rules"},{"anchor":"implementing-membrane-bin","id":"Implementing Membrane.Bin"},{"anchor":"consuming-data","id":"Consuming data"},{"anchor":"subscribing-for-a-track","id":"Subscribing for a track"}],"id":"custom_endpoints","title":"Custom endpoint"},{"group":"Guides","headers":[{"anchor":"turning-simulcast-on-off","id":"Turning simulcast on/off"}],"id":"simulcast","title":"Simulcast"},{"group":"Guides","headers":[],"id":"logs","title":"Logs"},{"group":"Guides","headers":[],"id":"metrics","title":"Metrics"},{"group":"Guides","headers":[],"id":"traces","title":"Traces"}],"modules":[{"group":"","id":"Membrane.RTC.Engine","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:custom_media_event_action_t/0","id":"custom_media_event_action_t/0"},{"anchor":"t:endpoint_options_t/0","id":"endpoint_options_t/0"},{"anchor":"t:options_t/0","id":"options_t/0"},{"anchor":"t:publish_action_t/0","id":"publish_action_t/0"},{"anchor":"t:publish_message_t/0","id":"publish_message_t/0"},{"anchor":"t:subscription_opts_t/0","id":"subscription_opts_t/0"},{"anchor":"t:track_ready_action_t/0","id":"track_ready_action_t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"accept_peer/2","id":"accept_peer/2"},{"anchor":"add_endpoint/3","id":"add_endpoint/3"},{"anchor":"add_peer/2","id":"add_peer/2"},{"anchor":"deny_peer/2","id":"deny_peer/2"},{"anchor":"deny_peer/3","id":"deny_peer/3"},{"anchor":"get_registry_name/0","id":"get_registry_name/0"},{"anchor":"message_endpoint/3","id":"message_endpoint/3"},{"anchor":"play/1","id":"play/1"},{"anchor":"prepare/1","id":"prepare/1"},{"anchor":"receive_media_event/2","id":"receive_media_event/2"},{"anchor":"register/2","id":"register/2"},{"anchor":"remove_endpoint/2","id":"remove_endpoint/2"},{"anchor":"remove_peer/3","id":"remove_peer/3"},{"anchor":"start/2","id":"start/2"},{"anchor":"start_link/2","id":"start_link/2"},{"anchor":"stop/1","id":"stop/1"},{"anchor":"stop_and_terminate/2","id":"stop_and_terminate/2"},{"anchor":"subscribe/4","id":"subscribe/4"},{"anchor":"terminate/2","id":"terminate/2"},{"anchor":"unregister/2","id":"unregister/2"}]}],"sections":[{"anchor":"module-messages","id":"Messages"},{"anchor":"module-client-libraries","id":"Client Libraries"},{"anchor":"module-peers","id":"Peers"},{"anchor":"module-endpoints","id":"Endpoints"}],"title":"Membrane.RTC.Engine"},{"group":"","id":"Membrane.RTC.Engine.Metrics","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:rtc_engine_report/0","id":"rtc_engine_report/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"metrics/0","id":"metrics/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Metrics"},{"group":"","id":"Membrane.RTC.Engine.Notifications.TrackNotification","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[{"anchor":"module-publishing-the-notification","id":"Publishing the notification"}],"title":"Membrane.RTC.Engine.Notifications.TrackNotification"},{"group":"","id":"Membrane.RTC.Engine.Peer","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:id/0","id":"id/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"new/2","id":"new/2"}]}],"sections":[],"title":"Membrane.RTC.Engine.Peer"},{"group":"","id":"Membrane.RTC.Engine.Track","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:encoding/0","id":"encoding/0"},{"anchor":"t:id/0","id":"id/0"},{"anchor":"t:opts_t/0","id":"opts_t/0"},{"anchor":"t:t/0","id":"t/0"},{"anchor":"t:variant/0","id":"variant/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"get_depayloader/1","id":"get_depayloader/1"},{"anchor":"new/7","id":"new/7"},{"anchor":"stream_id/0","id":"stream_id/0"},{"anchor":"supported_variants/0","id":"supported_variants/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Track"},{"group":"","id":"Membrane.RTC.Engine.Track.BitrateEstimation","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Track.BitrateEstimation"},{"group":"","id":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.AllocationGrantedNotification","nested_context":"Membrane.RTC.Engine.Endpoint","nested_title":".WebRTC.ConnectionAllocator.AllocationGrantedNotification","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator.AllocationGrantedNotification"},{"group":"Endpoints","id":"Membrane.RTC.Engine.Endpoint.HLS","nested_context":"Membrane.RTC.Engine.Endpoint","nested_title":".HLS","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"membrane_pads/0","id":"membrane_pads/0"},{"anchor":"options/0","id":"options/0"}]}],"sections":[{"anchor":"module-bin-options","id":"Bin options"},{"anchor":"module-pads","id":"Pads"}],"title":"Membrane.RTC.Engine.Endpoint.HLS"},{"group":"Endpoints","id":"Membrane.RTC.Engine.Endpoint.HLS.TranscodingConfig","nested_context":"Membrane.RTC.Engine.Endpoint","nested_title":".HLS.TranscodingConfig","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Endpoint.HLS.TranscodingConfig"},{"group":"Endpoints","id":"Membrane.RTC.Engine.Endpoint.WebRTC","nested_context":"Membrane.RTC.Engine.Endpoint","nested_title":".WebRTC","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:encoding_t/0","id":"encoding_t/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"membrane_pads/0","id":"membrane_pads/0"},{"anchor":"options/0","id":"options/0"}]}],"sections":[{"anchor":"module-bin-options","id":"Bin options"},{"anchor":"module-pads","id":"Pads"}],"title":"Membrane.RTC.Engine.Endpoint.WebRTC"},{"group":"Endpoints","id":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator","nested_context":"Membrane.RTC.Engine.Endpoint","nested_title":".WebRTC.ConnectionAllocator","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:allocator_ref/0","id":"allocator_ref/0"},{"anchor":"t:decrease_allocation_request/0","id":"decrease_allocation_request/0"},{"anchor":"t:decrease_allocation_request_response/0","id":"decrease_allocation_request_response/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:buffer_sent/2","id":"buffer_sent/2"},{"anchor":"c:create/0","id":"create/0"},{"anchor":"c:destroy/1","id":"destroy/1"},{"anchor":"c:probe_sent/1","id":"probe_sent/1"},{"anchor":"c:register_track_receiver/4","id":"register_track_receiver/4"},{"anchor":"c:request_allocation/2","id":"request_allocation/2"},{"anchor":"c:set_negotiability_status/2","id":"set_negotiability_status/2"},{"anchor":"c:update_bandwidth_estimation/2","id":"update_bandwidth_estimation/2"}]}],"sections":[{"anchor":"module-granting-an-allocation","id":"Granting an allocation"},{"anchor":"module-negotiating-lower-allocation","id":"Negotiating lower allocation"}],"title":"Membrane.RTC.Engine.Endpoint.WebRTC.ConnectionAllocator"},{"group":"Endpoints","id":"Membrane.RTC.Engine.Endpoint.WebRTC.NoOpConnectionAllocator","nested_context":"Membrane.RTC.Engine.Endpoint","nested_title":".WebRTC.NoOpConnectionAllocator","sections":[],"title":"Membrane.RTC.Engine.Endpoint.WebRTC.NoOpConnectionAllocator"},{"group":"Endpoints","id":"Membrane.RTC.Engine.Endpoint.WebRTC.SimulcastConfig","nested_context":"Membrane.RTC.Engine.Endpoint","nested_title":".WebRTC.SimulcastConfig","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"initial_target_variant/1","id":"initial_target_variant/1"}]}],"sections":[],"title":"Membrane.RTC.Engine.Endpoint.WebRTC.SimulcastConfig"},{"group":"Endpoints","id":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver","nested_context":"Membrane.RTC.Engine.Endpoint","nested_title":".WebRTC.TrackReceiver","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:control_messages/0","id":"control_messages/0"},{"anchor":"t:notifications/0","id":"notifications/0"},{"anchor":"t:set_negotiable?/0","id":"set_negotiable?/0"},{"anchor":"t:set_target_variant/0","id":"set_target_variant/0"},{"anchor":"t:t/0","id":"t/0"},{"anchor":"t:variant_switched/0","id":"variant_switched/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"membrane_pads/0","id":"membrane_pads/0"},{"anchor":"options/0","id":"options/0"}]}],"sections":[{"anchor":"module-element-options","id":"Element options"},{"anchor":"module-pads","id":"Pads"}],"title":"Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver"},{"group":"Events","id":"Membrane.RTC.Engine.Event.RequestTrackVariant","nested_context":"Membrane.RTC.Engine.Event","nested_title":".RequestTrackVariant","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Event.RequestTrackVariant"},{"group":"Events","id":"Membrane.RTC.Engine.Event.TrackVariantPaused","nested_context":"Membrane.RTC.Engine.Event","nested_title":".TrackVariantPaused","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Event.TrackVariantPaused"},{"group":"Events","id":"Membrane.RTC.Engine.Event.TrackVariantResumed","nested_context":"Membrane.RTC.Engine.Event","nested_title":".TrackVariantResumed","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Event.TrackVariantResumed"},{"group":"Events","id":"Membrane.RTC.Engine.Event.TrackVariantSwitched","nested_context":"Membrane.RTC.Engine.Event","nested_title":".TrackVariantSwitched","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Event.TrackVariantSwitched"},{"group":"Messages","id":"Membrane.RTC.Engine.Message","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Message"},{"group":"Messages","id":"Membrane.RTC.Engine.Message.EndpointCrashed","nested_context":"Membrane.RTC.Engine.Message","nested_title":".EndpointCrashed","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Message.EndpointCrashed"},{"group":"Messages","id":"Membrane.RTC.Engine.Message.MediaEvent","nested_context":"Membrane.RTC.Engine.Message","nested_title":".MediaEvent","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Message.MediaEvent"},{"group":"Messages","id":"Membrane.RTC.Engine.Message.NewPeer","nested_context":"Membrane.RTC.Engine.Message","nested_title":".NewPeer","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Message.NewPeer"},{"group":"Messages","id":"Membrane.RTC.Engine.Message.PeerLeft","nested_context":"Membrane.RTC.Engine.Message","nested_title":".PeerLeft","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Membrane.RTC.Engine.Message.PeerLeft"},{"group":"Exceptions","id":"Membrane.RTC.Engine.Exception.PublishTrackError","nested_context":"Membrane.RTC.Engine.Exception","nested_title":".PublishTrackError","sections":[],"title":"Membrane.RTC.Engine.Exception.PublishTrackError"},{"group":"Exceptions","id":"Membrane.RTC.Engine.Exception.RequestTrackVariantError","nested_context":"Membrane.RTC.Engine.Exception","nested_title":".RequestTrackVariantError","sections":[],"title":"Membrane.RTC.Engine.Exception.RequestTrackVariantError"},{"group":"Exceptions","id":"Membrane.RTC.Engine.Exception.TrackReadyError","nested_context":"Membrane.RTC.Engine.Exception","nested_title":".TrackReadyError","sections":[],"title":"Membrane.RTC.Engine.Exception.TrackReadyError"},{"group":"Exceptions","id":"Membrane.RTC.Engine.Exception.TrackVariantStateError","nested_context":"Membrane.RTC.Engine.Exception","nested_title":".TrackVariantStateError","sections":[],"title":"Membrane.RTC.Engine.Exception.TrackVariantStateError"}],"tasks":[]}